const  Roboto  = require("./Roboto-Regular-normal").Roboto;

class createPDF {
/**
* @route GET /createProjectInvoice
* @param {String} id 
*/



async createProjectInvoice(id) {

// -------------  preparation of data for pdf file
  let billingRateOrPrice, billingType, companyName, currencyCode, list, project, reg, vat, projectName, url;

  project = (await Backendless.Data.of('Project').find(Backendless.DataQueryBuilder.create().setWhereClause((['objectId=\'',id,'\''].join(''))).setRelationsDepth(1).setPageSize(10)))[0];
  companyName = ((((project['company'])['billingInfo'])[0])['billingName']);
  projectName = project['title'];
  billingType = (project['billingType']);
  billingRateOrPrice = (project['billingRateOrPrice']);
  currencyCode = (project['currencyCode']);
  reg = ((((project['company'])['billingInfo'])[0])['reg']);
  vat = ((((project['company'])['billingInfo'])[0])['vat']);
 
// ------- create PDF document start
const { jsPDF } = require("../lib/jspdf"); 
const doc = new jsPDF();

doc.addFileToVFS('Roboto-Regular.ttf', Roboto);
doc.addFont('Roboto-Regular.ttf', 'Roboto', 'normal');
doc.setFont('Roboto', 'normal', 400);

doc.setFontSize(22);
doc.text(`Invoice: ${companyName}  `, 10, 13,  {maxWidth: 200, lineHeightFactor: 1}); 
doc.line(10, 22,200, 22);
doc.setFontSize(16);
doc.text(`Company name: ${companyName}  `, 10, 32,  {maxWidth: 195, lineHeightFactor: 0.8});
doc.text(`Project name: ${projectName}  `, 10, 42, {maxWidth: 195, lineHeightFactor: 0.8});
doc.text(`Billing type: ${billingType}  `, 10, 52);
doc.text(`Billing price: ${billingRateOrPrice}${currencyCode} `, 10, 62);
doc.text(`Vat Number: ${vat}`, 10, 72);
doc.text(`Registration  Number: ${reg}`, 10, 82);
doc.setFillColor(211, 211, 211);
doc.rect(10, 90, 190, 20, "F");
doc.setFontSize(22);
doc.text(`TOTAL: ${billingRateOrPrice}${currencyCode}`, 15, 102);

let byteArray = doc.output('arraybuffer');
// ------- create PDF document end
let fileName =  Date.now() + '.pdf' ;
url = await Backendless.Files.saveFile( "pdf", fileName, byteArray, true)
 
  return url
}

// ==================================================================================================

/**
* @route GET /createEstimate
* @param {String} id 
*/

async createEstimate(id) {
  let estimate, items, company, supplier, url, subtotal, textHeight, lineHeight, totalPrice, firstPageItems, allItems;
  
  estimate = (await Backendless.Data.of('Estimate').find(Backendless.DataQueryBuilder.create().setWhereClause((['objectId=\'',id,'\''].join(''))).setRelationsDepth(1).setPageSize(100)))[0];
  items = (await Backendless.Data.of('Estimate').loadRelations((estimate['objectId']), Backendless.LoadRelationsQueryBuilder.create().setRelationName('items').setPageSize(100).setOffset(0)));
  company = estimate['company'].billingInfo[0];
  supplier = (await Backendless.Data.of('Supplier').find(Backendless.DataQueryBuilder.create().setRelationsDepth(1).setPageSize(100)))[0];

  if (items.length >17) {
    
    firstPageItems = items.slice (0, 17);
    allItems = items.slice (17);
    
  } else {
    
    firstPageItems = items;
  }

  totalPrice = 0;
  
  items.forEach(item => {
    
    let subtotal = item.quantity*item.unitPrice + item.quantity*item.unitPrice*(item.taxRate/100);
    subtotal = (Math.round(subtotal*100))/100;
    totalPrice += subtotal;  
    
  });
  
  totalPrice = (Math.round(totalPrice*100))/100;  

  // ------- create PDF document start
  const { jsPDF } = require("../lib/jspdf"); 
  const doc = new jsPDF();
  
  doc.addFileToVFS('Roboto-Regular.ttf', Roboto);
  doc.addFont('Roboto-Regular.ttf', 'Roboto', 'normal');
  doc.setFont('Roboto', 'normal', 400);

  doc.setFontSize(18);
  doc.text(`Estimate`, 10, 20);
  doc.line(10, 25,200, 25);

  doc.setFillColor(236, 236, 236);
  doc.rect(10, 30, 90, 50, "F");

  doc.setFontSize(14);
  doc.setFont("Roboto", "bold"); 
  doc.text(`Supplier`, 15, 40);
  doc.setFont("Roboto", "normal");
  doc.setFontSize(11);
  doc.text(`Name:      ${supplier.name}`, 15, 50, {maxWidth: 80});
  doc.text(`Reg. No.:  ${supplier.registrationNo}`, 15, 60, {maxWidth: 80});
  doc.text(`VAT No.:   ${supplier.vatNo}`, 15, 70, {maxWidth: 80});

  doc.setFillColor(236, 236, 236);
  doc.rect(110, 30, 90, 50, "F");

  doc.setFontSize(14);
  doc.setFont("Roboto", "bold");
  doc.text(`Customer`, 115, 40);
  doc.setFont("Roboto", "normal");
  doc.setFontSize(11);
  doc.text(`Name:      ${company.billingName}`, 115, 50, {maxWidth: 80});
  doc.text(`Reg. No.:  ${company.reg}`, 115, 60, {maxWidth: 80});
  doc.text(`VAT No.:   ${company.vat}`, 115, 70, {maxWidth: 80});
// ----- table ------
  doc.setFont("Roboto", "bold");
  doc.text(`Item`, 10, 90);
  doc.text(`Quantity`, 70, 90);
  doc.text(`Unit price`, 90, 90);
  doc.text(`Tax rate`, 120, 90);
  doc.text(`Subtotal`, 150, 90);
  doc.text(`Currency`, 180, 90);
  doc.line(10, 95,200, 95);

  doc.setFont("Roboto", "normal");
  doc.setFontSize(10);

  textHeight = 100;
  lineHeight = 105;
  
  firstPageItems.forEach(item => {
    
    doc.text(`${item.title}`, 10, textHeight, {maxWidth: 60, lineHeightFactor: 1}); 
    doc.text(`${item.quantity}`, 70, textHeight);
    doc.text(`${item.unitPrice}`, 90, textHeight);
    doc.text(`${item.taxRate}%`, 120, textHeight);
    let subtotal = item.quantity*item.unitPrice + item.quantity*item.unitPrice*(item.taxRate/100);
    subtotal = (Math.round(subtotal*100))/100;
    doc.text(`${subtotal}`, 150, textHeight);
    doc.text(`${estimate['currencyCode']}`, 180, textHeight);
    doc.line(10, lineHeight, 200, lineHeight);
  
    textHeight+=10;
    lineHeight+=10;
    
  });

  if (items.length > 17) {
    
    let step = 0;

    for (let i=0; i<(allItems.length/25);i++) {
    
      doc.addPage("a4");

      doc.setFont("Roboto", "bold");
      doc.text(`Item`, 10, 10);
      doc.text(`Quantity`, 70, 10);
      doc.text(`Unit price`, 90, 10);
      doc.text(`Tax rate`, 120, 10);
      doc.text(`Subtotal`, 150, 10);
      doc.text(`Currency`, 180, 10);
      doc.line(10, 15,200, 15);
      doc.setFont("Roboto", "normal");
      doc.setFontSize(10);
      textHeight = 20; 
      lineHeight = 25; 

      for (let j=step; j<(step+25); j++) {
        if (allItems[j]) {
        
          doc.text(`${allItems[j].title}`, 10, textHeight, {maxWidth: 60, lineHeightFactor: 1}); 
          doc.text(`${allItems[j].quantity}`, 70, textHeight);
          doc.text(`${allItems[j].unitPrice}`, 90, textHeight);
          doc.text(`${allItems[j].taxRate}%`, 120, textHeight);
          let subtotal = allItems[j].quantity*allItems[j].unitPrice + allItems[j].quantity*allItems[j].unitPrice*(allItems[j].taxRate/100);
          subtotal = (Math.round(subtotal*100))/100;
          doc.text(`${subtotal}`, 150, textHeight);
          doc.text(`${estimate['currencyCode']}`, 180, textHeight);
          doc.line(10, lineHeight, 200, lineHeight);
          textHeight+=10;
          lineHeight+=10;
        }
      }
      
    step+=25;    
  }
}

  doc.setFont("Roboto", "bold");
  doc.setFontSize(12);
  doc.text(`Total: ${totalPrice} ${estimate['currencyCode']}`, 200, lineHeight, null, null, "right");

  let byteArray = doc.output('arraybuffer');
  // ------- create PDF document end

  let fileName =  Date.now() + '.pdf' ;

  url = await Backendless.Files.saveFile( "pdf", fileName, byteArray, true);
  
  return url
}


// ==================================================================================================

/**
* @route GET /createInvoice
* @param {String} id 
* @param {String} issuedDate 
*/

async createInvoice (id, issuedDate) {
  let invoice, items, url, textHeight, lineHeight, totalPrice, firstPageItems, allItems;
  
  invoice = (await Backendless.Data.of('Invoice').find(Backendless.DataQueryBuilder.create().setWhereClause((['objectId=\'',id,'\''].join(''))).setPageSize(100)))[0];
 
  items = (await Backendless.Data.of('Invoice').loadRelations((invoice['objectId']), Backendless.LoadRelationsQueryBuilder.create().setRelationName('invoiceItems').setPageSize(100).setOffset(0)));
  
  if (items.length >12) {
    firstPageItems = items.slice (0, 12);
    allItems = items.slice (12);
  } else {
    firstPageItems = items;
  }
  
  totalPrice = 0;
  items.forEach(item => {
    let subtotal = item.quantity*item.unitPrice + item.quantity*item.unitPrice*(item.tax/100);
    subtotal = (Math.round(subtotal*100))/100;  
    totalPrice += subtotal;    
  });
  totalPrice = (Math.round(totalPrice*100))/100;
  
  // ------- create PDF document start
  const { jsPDF } = require("../lib/jspdf"); 
  const doc = new jsPDF();
  
  doc.addFileToVFS('Roboto-Regular.ttf', Roboto);
  doc.addFont('Roboto-Regular.ttf', 'Roboto', 'normal');
  doc.setFont('Roboto', 'normal', 400);
  
  doc.setFontSize(18);
  doc.text(`Invoice #${invoice.number}`, 10, 20);
  doc.setDrawColor(236, 236, 236);
  doc.line(10, 25,200, 25);
  
  doc.rect(10, 30, 90, 30);
  doc.setFontSize(11);
  doc.text(`Issue date:          ${issuedDate}`, 15, 40);
  doc.text(`Payment term:    ${invoice.paymentTerm} days`, 15, 50);
 
  doc.rect(110, 30, 90, 30);
  doc.text(`Instructions:      ${invoice.instruction}`, 115, 40, {maxWidth: 80});
  
  doc.setFillColor(236, 236, 236);
  doc.rect(10, 70, 90, 65, "F");
  doc.setFontSize(14);
  doc.setFont("Roboto", "bold");
  doc.text(`Supplier`, 15, 80);
  doc.setFont("Roboto", "normal");
  doc.setFontSize(11);
  doc.text(`Name:      ${invoice.supplierBillingName}`, 15, 90, {maxWidth: 80});
  doc.text(`Reg. No.:  ${invoice.supplierRegNo}`, 15, 100, {maxWidth: 80});
  doc.text(`VAT No.:   ${invoice.supplierVatNo}`, 15, 110, {maxWidth: 80});
  doc.text(`Details:     ${invoice.supplierDetails}`, 15, 120, {maxWidth: 80});

  doc.setFillColor(236, 236, 236);
  doc.rect(110, 70, 90, 65, "F");
  doc.setFontSize(14);
  doc.setFont("Roboto", "bold");
  doc.text(`Customer`, 115, 80);
  doc.setFont("Roboto", "normal");
  doc.setFontSize(11);
  doc.text(`Name:      ${invoice.customerBillingName}`, 115, 90, {maxWidth: 80});
  doc.text(`Reg. No.:  ${invoice.customerRegNo}`, 115, 100, {maxWidth: 80});
  doc.text(`VAT No.:   ${invoice.customerVatNo}`, 115, 110, {maxWidth: 80});
  doc.text(`Details:      ${invoice.customerDetails}`, 115, 120, {maxWidth: 80});

// ----- table ------
  doc.setFont("Roboto", "bold");
  doc.text(`Item`, 10, 145);
  doc.text(`Quantity`, 70, 145);
  doc.text(`Unit price`, 90, 145);
  doc.text(`Tax rate`, 120, 145);
  doc.text(`Subtotal`, 150, 145);
  doc.text(`Currency`, 180, 145);
  doc.line(10, 150, 200, 150);

  doc.setFont("Roboto", "normal");
  doc.setFontSize(10);
  textHeight = 155;
  lineHeight = 160;
  
  firstPageItems.forEach(item => {
    doc.text(`${item.title}`, 10, textHeight, {maxWidth: 60, lineHeightFactor: 1});
    doc.text(`${item.quantity}`, 70, textHeight);
    doc.text(`${item.unitPrice}`, 90, textHeight);
    doc.text(`${item.tax}%`, 120, textHeight);   
    let subtotal = item.quantity*item.unitPrice + item.quantity*item.unitPrice*(item.tax/100);
    subtotal = (Math.round(subtotal*100))/100;
    doc.text(`${subtotal}`, 150, textHeight);
    doc.text(`${invoice['currencyCode']}`, 180, textHeight);
    doc.line(10, lineHeight, 200, lineHeight);
    textHeight+=10;
    lineHeight+=10;
  }); 
  
  if (items.length > 12) {
    
    let step = 0;

    for (let i=0; i<(allItems.length/25);i++) {
      doc.addPage("a4");

      doc.setFont("Roboto", "bold");
      doc.text(`Item`, 10, 10); 
      doc.text(`Quantity`, 70, 10); 
      doc.text(`Unit price`, 90, 10); 
      doc.text(`Tax rate`, 120, 10); 
      doc.text(`Subtotal`, 150, 10); 
      doc.text(`Currency`, 180, 10); 
      doc.line(10, 15, 200, 15); 

      doc.setFont("Roboto", "normal");
      doc.setFontSize(10);
      textHeight = 20; 
      lineHeight = 25; 

      for (let j=step; j<(step+25); j++) {
        if (allItems[j]) {
          doc.text(`${allItems[j].title}`, 10, textHeight, {maxWidth: 60, lineHeightFactor: 1});
          doc.text(`${allItems[j].quantity}`, 70, textHeight);
          doc.text(`${allItems[j].unitPrice}`, 90, textHeight);
          doc.text(`${allItems[j].tax}%`, 120, textHeight);   
          let subtotal = allItems[j].quantity*allItems[j].unitPrice + allItems[j].quantity*allItems[j].unitPrice*(allItems[j].tax/100);
          subtotal = (Math.round(subtotal*100))/100;
          doc.text(`${subtotal}`, 150, textHeight);
          doc.text(`${invoice['currencyCode']}`, 180, textHeight);
          doc.line(10, lineHeight, 200, lineHeight);
          textHeight+=10;
          lineHeight+=10;
        }
      }
      step+=25;    
    }
  }
 
    doc.setFont("Roboto", "bold");
    doc.setFontSize(12);
    doc.text(`Total: ${totalPrice} ${invoice['currencyCode']}`, 200, lineHeight, null, null, "right");
  

  let byteArray = doc.output('arraybuffer');
  
// ------- create PDF document end

  let fileName =  Date.now() + '.pdf' ;

  url = await Backendless.Files.saveFile( "pdf", fileName, byteArray, true);
  
  return url
}

}

Backendless.ServerCode.addService(createPDF);